<script lang="ts">
	import type { HTMLInputAttributes } from 'svelte/elements';

	export let id: string;
	export let name: string;
	export let placeholder: string = '';
	export let type: 'text' | 'date' = 'text';
	export let label: string;
	export let value: string | undefined;
	export let constraints: any;
	export let errorText: string | undefined = '';
	export let rest: HTMLInputAttributes | null = null;

	const things = {
		id,
		name,
		placeholder: `| ${placeholder}`,
		...constraints,
		...rest
	};
</script>

<div class="container">
	<label for={id}>
		<h3>{label}</h3>
	</label>
	{#if type === 'text'}
		<input type="text" bind:value {...things} />
	{:else}
		<input type="date" bind:value {...things} />
	{/if}
	<small>{errorText ?? ''}</small>
</div>

<style>
	.container {
		flex: 1;
		width: 100%;
		box-sizing: border-box;
		position: relative;
		& input {
			width: 100%;
			box-sizing: border-box;
			height: 50px;
			padding: 0px 24px;
			background: linear-gradient(var(--manga-2), var(--manga-2)) padding-box,
				var(--border-color) border-box;
			border: 3px solid transparent;
			border-radius: 3px;
			font-size: var(--font-small);
			font-weight: var(--weight-regular);
			line-height: 26.4px;
			color: var(--manga-4);
		}
		& input::-webkit-outer-spin-button,
		input::-webkit-inner-spin-button {
			-webkit-appearance: none;
			margin: 0;
		}

		& input[type='number'] {
			appearance: none;
			-moz-appearance: textfield;
		}

		& label h3 {
			margin-bottom: 24px;
		}

		& small {
			color: #e25b4e;
			display: block;
			position: absolute;
			bottom: -18px;
		}
	}

	@media only screen and (max-width: 1120px) {
		.container label h3 {
			margin-bottom: 12px;
		}
	}
</style>
